'********************************************
'************    Ver_EdW_1.1   **************
'***           Projekt okadkowy        *****
'****** Tomasz Gajda, tobi2@interia.pl ******
'********************************************

$regfile = "8515DEF.DAT"
$crystal = 4000000

Config Porta = Output
   Config Pind.7 = Output
   Config Pind.6 = Output
   Config Pind.5 = Output


'*******************************************************************************
'************* Procedura wyzerowania wczystkich lach'y (hc573) *****************
'*******************************************************************************
Portc = 0
Config Portc = Output
Porta = 255
Set Portd.6
nop
nop
Porta = 0
nop
Set Portd.7
Reset Portd.6
nop
nop
Reset Portd.7
nop
Portb = 0
Config Portb = Output

'*******************************************************************************
Wait 1
Declare Sub Read1820
Config 1wire = Portd.3

'*******************************************************************************
'***************** Deklaracje zmiennych ****************************************
'*******************************************************************************
Dim Bit_data As Bit
Dim Data_in_fp2800 As Byte
Dim Data_enable_fp As Byte
Dim Nr_kolumny As Byte
Dim Lo_wiersze As Byte , Hi_wiersze As Byte                 'mlodsza  i starsza czesc kolumny
Dim Nr_fp2800 As Byte
Dim Licznik As Byte
Dim Licznik2 As Byte
Dim Licznik3 As Byte
Dim Licznik4 As Byte
Dim Nr As Byte
Dim Data_a As Byte
Dim Bd(9) As Byte

Dim Te As Long
Dim T As Long
Dim T2 As Long

Const Ilosc_kolumn2 = 56                                    '!!!!!!!parzysta liczba 252 168 56 zalezy od wielkosci tablicy pixelowej, inaczej jest to liczba kolumn*2
Dim Tablica_danych(ilosc_kolumn2) As Byte
Dim X As Byte
Dim Zmiana_temp As Long

     Gosub Czysc_tablice_danych
     Restore Edw
      For Licznik = 1 To 54
           Read Tablica_danych(licznik)
      Next
     Gosub Wyswietl_tablice_danych
Wait 1

'*******************************************************************************
'******************************* MAIN LOOP *************************************
'*******************************************************************************
Do
Gosub Read1820
If Zmiana_temp <> T Then
Gosub Czysc_tablice_danych

Powtorz:
Select Case T                                               'pamietaj ze dla temp np= 23,4'C zmienna T przyjmuje wartosc 234

Case -9 To -1:
     Restore Minus
         For Licznik = 1 To 12                              'laduj do RAM ZERO
            Read Tablica_danych(licznik)
         Next Licznik
     T = Abs(t)
     goto powtorz

Case 0 To 9:                                                'to case dla temperatur od 0,0 do 0,9 czyli dla T od 0 do 9
      Restore Cyfry
         For Licznik = 15 To 26                             'laduj do RAM ZERO
            Read Tablica_danych(licznik)
         Next Licznik

         Tablica_danych(30) = &B00011100                    ' przecinek

      X = 14 * T                                            'liczba 14 to ilosc bajtow przeznaczonych na cyfre wraz z jedna pusta kolumna
      Restore Cyfry                                         'zainicjuj tablice z cyframi
         For Licznik = 1 To X                               'wywolaj nie niepotrzebne mienne
            Read Licznik3
         Next Licznik

         For Licznik = 33 To 46                             'zaladuj do RAM (Tablicy_danych) cyfre odpowiadajaca liczbie T
            Read Tablica_danych(licznik)
         Next Licznik

      Restore Znak_celsjusza                                'zainicjuj tablice ze znakiem celsjusza
      For Licznik = 47 To 56                                'pobierz do ramu ten znak
         Read Tablica_danych(licznik)
      Next Licznik


Case 10 To 99:                                              'dla temp 1,0C do 9,9C
            Te = T / 10                                     'wydziel czesc calkowita, pierwsza cyfre
            X = 14 * Te                                     ' to samo co w "Case 0 To 9:"

      Restore Cyfry
         For Licznik = 1 To X
            Read Licznik3
         Next Licznik

         For Licznik = 15 To 26
            Read Tablica_danych(licznik)
         Next Licznik

            Te = T Mod 10                                   'wydziel druga cyfre, jednosci
            X = 14 * Te

         Tablica_danych(30) = &B00011100                    'przecinek

      Restore Cyfry
         For Licznik = 1 To X
            Read Licznik3
         Next Licznik

         For Licznik = 33 To 46
            Read Tablica_danych(licznik)
         Next Licznik

      Restore Znak_celsjusza
        For Licznik = 47 To 56
           Read Tablica_danych(licznik)
        Next Licznik


Case 100 To 999:                                            'dla temp 10,0C do 99,9C
            Te = T / 100                                    'wydziel pierwsza cyfre, setki
            X = 14 * Te                                     '

      Restore Cyfry
        For Licznik = 1 To X
           Read Licznik3
        Next Licznik

        For Licznik = 1 To 12
           Read Tablica_danych(licznik)
        Next Licznik


            Te = T / 10                                     ' wydziel druga cyfre, dziesiatki
            Te = Te Mod 10                                  '
            X = 14 * Te                                     '

      Restore Cyfry
         For Licznik = 1 To X
            Read Licznik3
         Next Licznik

         For Licznik = 15 To 26
            Read Tablica_danych(licznik)
         Next Licznik

         Tablica_danych(30) = &B00011100                    ' przecinek


            Te = T Mod 10                                   ' wydziel trzecia cyfre, jednosci
            X = 14 * Te                                     '

      Restore Cyfry
            For Licznik = 1 To X
               Read Licznik3
            Next Licznik

            For Licznik = 33 To 46
               Read Tablica_danych(licznik)
            Next Licznik

      Restore Znak_celsjusza
            For Licznik = 47 To 56
               Read Tablica_danych(licznik)
            Next Licznik

   Case Else:
     Gosub Czysc_tablice_danych
     Restore Ol
      For Licznik = 15 To 42
           Read Tablica_danych(licznik)
      Next
End Select
Gosub Wyswietl_tablice_danych                               '
Zmiana_temp = T
End If
Loop

'*******************************************************************************
'************** Procedura wyswielania inf na tablicy ***************************
'*******************************************************************************
Wyswietl_tablice_danych:
Nr_kolumny = 1
Nr_fp2800 = 1                                               'wieksze tablice skladaja sie z kilku identycznych modulow

   For Licznik = 1 To Ilosc_kolumn2 Step 2                  'wykonuje petle for tyle ile jest zadeklarowanych kolumn dla tablicy
     Hi_wiersze = Tablica_danych(licznik)                   'MSB kolumny
     Lo_wiersze = Tablica_danych(licznik + 1)               'LSB kolumny

      For Licznik2 = 0 To 7
         Nr = 0
         Bit_data = Lo_wiersze.licznik2                     'Bit_data niesie informacje o tym czy pixel ma byc zapalony czy zgaszony
         Gosub Zalacz_wiersze
         Gosub Wybor_kolumny                                ''(nr_kolumny)
      Next Licznik2

      For Licznik2 = 0 To 7
         Nr = 1
         Bit_data = Hi_wiersze.licznik2
         Gosub Zalacz_wiersze                               ' dokladniej, ustawia dla kolejnego wiersza wartosc pixela typu set lub reset
         Gosub Wybor_kolumny                                ' ustawia kolejna kolumne, nastepnie zezwala na jej wyswetlenie (dokladnie na wyswietlenie jednego pixela)
      Next Licznik2

      Incr Nr_kolumny
   Next Licznik
Return

'*******************************************************************************
Zalacz_wiersze:
   If Bit_data = 0 Then
      Restore Nr_fp_i__nr_kolejnej_jedynki
         For Licznik3 = 0 To Licznik2
            Read Data_a
         Next Licznik3
         Portc = Data_a

      Restore En_uln
         For Licznik3 = 0 To Nr
            Read Data_a
         Next Licznik3
        Porta = Data_a

          Set Portd.6
          nop
          nop
          nop
          Reset Portd.6

   Else
      Restore Nr_fp_i__nr_kolejnej_jedynki
         For Licznik3 = 0 To Licznik2
            Read Data_a
            Portc = Data_a
         Next Licznik3

      Restore En_udn
         For Licznik3 = 0 To Nr
            Read Data_a
         Next Licznik3
         Porta = Data_a

          Set Portd.6
          nop
          nop
          nop
          Reset Portd.6
   End If
Return

'*******************************************************************************
Wybor_kolumny:                                              
   Upp:
   If Nr_kolumny > 28 Then                                  'jesli mamy doczyniena z wiekszymi tablicami (wiecej niz 28 kolumn)
      Gosub Roznica
      Incr Nr_fp2800
      Goto Upp
   End If


   Restore Dta_kol                                          'zainicjowanie tablicy z inforacja co do numeru kolumny sterowanej przez FP2800
      For Licznik4 = 1 To Nr_kolumny
         Read Data_in_fp2800
      Next Licznik4                                         '4

   Restore Nr_fp_i__nr_kolejnej_jedynki
      For Licznik4 = 1 To Nr_fp2800
         Read Data_enable_fp
      Next Licznik4                                         '4

   Portb = Data_in_fp2800

   If Bit_data = 0 Then                                     ' ustaw alboo wygas pixel
      Set Portd.5
   Else
      Reset Portd.5
   End If

   Waitus 70
 Gosub Wybor_enable_fp                                      '''
Return

'**************** procedura zalaczenia wybranego FP2800 *************************
Wybor_enable_fp:
Porta = &B00000001                                          'Data_enable_fp
   Set Portd.7
      nop
      nop
      nop
   Reset Portd.7
Waitus 1100                                                 'czas potrzebny na wyswietlenie pixela, giczaa 24 FP2800
'Waitus 400

Porta = &B00000000
   Set Portd.7
      nop
      nop
      nop
   Reset Portd.7
   Gosub Ustaw_all_573_na0
Waitus 110
Return

'************* Ustawia wyjscia wszystkich hc573 na 0 ***************************
Ustaw_all_573_na0:
   Portc = 0
   Porta = 255
   Set Portd.6
   nop
   nop
   nop
   Reset Portd.6
   Porta = 0
   Set Portd.6
   nop
   nop
   nop
   Reset Portd.6
Portb = 0
Return

'*******************************************************************************
'********** Odczyt temperatury z czujnika DS1820 *******************************
'*******************************************************************************
Read1820:
   1wreset
   If Err = 0 Then
   1wwrite &HCC                                             'konwersja
   1wwrite &H44
   Waitms 800

      1wreset                                                     'inicjalizacja magistrali 1WIRE
       1wwrite &HCC                                               'danie dostpu do pamici RAM
       1wwrite &HBE
       Bd(1) = 1wread(9)

      T = 0
      T.0 = Bd(1).4
      T.1 = Bd(1).5
      T.2 = Bd(1).6
      T.3 = Bd(1).7
      T.4 = Bd(2).0
      T.5 = Bd(2).1
      T.6 = Bd(2).2

      T2 = 5000 * Bd(1).3
      Te = T2
      T2 = 2500 * Bd(1).2
      Te = Te + T2
      T2 = 1250 * Bd(1).1
      Te = Te + T2
      T2 = 650 * Bd(1).0
      Te = Te + T2
      Te = Te / 1000

      T = T * 10
      T = T + Te

      If Bd(2).7 = 1 Then
         T = T * -1
      End If

   Else
     Gosub Czysc_tablice_danych
     Restore Error
      For Licznik = 1 To 44
           Read Tablica_danych(licznik)
      Next
     Gosub Wyswietl_tablice_danych
   End If
Return
'*******************************************************************************
Roznica:
   Nr_kolumny = Nr_kolumny - 28
Return

'*******************************************************************************
Czysc_tablice_danych:
   For Licznik = 1 To Ilosc_kolumn2
      Tablica_danych(licznik) = 0
   Next Licznik
Return

'*******************************************************************************
'********************** Tablice sterujace **************************************
'*******************************************************************************
Dta_kol:
        '3G          '3F           '3E          '3D        '3C            '3B        '3A
Data &B00011111 , &B00011110 , &B00011101 , &B00011100 , &B00011011 , &B00011010 , &B00011001
        '2G          '2F           '2E          '2D        '2C            '2B        '2A
Data &B00010111 , &B00010110 , &B00010101 , &B00010100 , &B00010011 , &B00010010 , &B00010001
        '1G          '1F           '1E          '1D        '1C            '1B        '1A
Data &B00001111 , &B00001110 , &B00001101 , &B00001100 , &B00001011 , &B00001010 , &B00001001
        '0G          '0F           '0E          '0D        '0C            '0B        '1A
Data &B00000111 , &B00000110 , &B00000101 , &B00000100 , &B00000011 , &B00000010 , &B00000001
         'x        'x           'x

Nr_fp_i__nr_kolejnej_jedynki:
Data &B00000001 , &B00000010 , &B00000100 , &B00001000
Data &B00010000 , &B00100000 , &B01000000 , &B10000000

En_udn:
Data &B00000001 , &B00000010 , &B00010000 , &B00100000

En_uln:
Data &B00000100 , &B00001000 , &B01000000 , &B10000000


'*******************************************************************************
'*******************************************************************************
'************** TABLICE CYFR  **************************************************
'*******************************************************************************
Cyfry:
'zero
Data &B00111111 , &B11111000
Data &B01111111 , &B11111100
Data &B01100000 , &B00001100
Data &B01100000 , &B00001100
Data &B01111111 , &B11111100
Data &B00111111 , &B11111000

Data &B00000000 , &B00000000
'jeden
Data &B00011000 , &B00001100
Data &B00111000 , &B00001100
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100

Data &B00000000 , &B00000000
'dwa
Data &B00111000 , &B00011100
Data &B01111000 , &B00111100
Data &B01100000 , &B01101100
Data &B01100000 , &B11001100
Data &B01111111 , &B10001100
Data &B00111111 , &B00001100

Data &B00000000 , &B00000000
'trzy
Data &B00111000 , &B01111000
Data &B01111000 , &B01111100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01111111 , &B11111100
Data &B00111100 , &B11111000

Data &B00000000 , &B00000000
'cztery
Data &B00000111 , &B10000000
Data &B00011101 , &B10000000
Data &B00110001 , &B10000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B00000001 , &B10000000

Data &B00000000 , &B00000000
'Piec
Data &B01111111 , &B00011000
Data &B01111111 , &B00011100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01110011 , &B11111100
Data &B01110001 , &B11111000

Data &B00000000 , &B00000000
'szesc
Data &B00111111 , &B11111000
Data &B01111111 , &B11111100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01110011 , &B11111100
Data &B00110001 , &B11111000

Data &B00000000 , &B00000000
'siedem
Data &B01110000 , &B00001100
Data &B01110000 , &B00111100
Data &B01100000 , &B11110000
Data &B01100001 , &B11000000
Data &B01111111 , &B10000000
Data &B01111110 , &B00000000

Data &B00000000 , &B00000000
'osiem
Data &B00111100 , &B11111000
Data &B01111111 , &B11111100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01111111 , &B11111100
Data &B00111100 , &B11111000

Data &B00000000 , &B00000000
'diewiec
Data &B00111110 , &B00011000
Data &B01111111 , &B00011100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01111111 , &B11111100
Data &B00111111 , &B11111000

Data &B00000000 , &B00000000

Znak_celsjusza:
Data &B00011000 , &B00000000
Data &B00100101 , &B11111000
Data &B00011010 , &B00000100
Data &B00000010 , &B00000100
Data &B00000010 , &B00000100


Error:
Data &B00000000 , &B00000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01100000 , &B00001100
Data &B00000000 , &B00000000
Data &B00000000 , &B00000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B01100011 , &B11000000
Data &B01100011 , &B01100000
Data &B01111111 , &B00111100
Data &B00011100 , &B00011100
Data &B00000000 , &B00000000
Data &B00000000 , &B00000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B01100011 , &B11000000
Data &B01100011 , &B01100000
Data &B01111111 , &B00111100
Data &B00011100 , &B00011100
Data &B00000000 , &B00000000

Edw:
Data &B00000000 , &B00000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B01100011 , &B00001100
Data &B01100011 , &B00001100
Data &B01100000 , &B00001100
Data &B01100000 , &B00001100
Data &B00000000 , &B00000000
Data &B00000000 , &B00000000
Data &B00000011 , &B11111000
Data &B00000111 , &B11111100
Data &B00000110 , &B00001100
Data &B00000110 , &B00001100
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B00000000 , &B00000000
Data &B00000000 , &B00000000
Data &B01111111 , &B11111000
Data &B01111111 , &B11111100
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100
Data &B00000000 , &B11111000
Data &B00000000 , &B11111000
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100
Data &B01111111 , &B11111100
Data &B01111111 , &B11111000
Data &B00000000 , &B00000000


Ol:
Data &B00111111 , &B11111000
Data &B01111111 , &B11111100
Data &B01100000 , &B00001100
Data &B01100000 , &B00001100
Data &B01111111 , &B11111100
Data &B00111111 , &B11111000
Data &B00000000 , &B00000000
Data &B00000000 , &B00000000
Data &B01111111 , &B11111100
Data &B01111111 , &B11111100
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100
Data &B00000000 , &B00001100


Minus:
Data &B00000011 , &B00000000
Data &B00000011 , &B00000000
Data &B00000011 , &B00000000
Data &B00000011 , &B00000000
Data &B00000011 , &B00000000
Data &B00000011 , &B00000000